// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.22.0
// source: run.sql

package generated

import (
	"context"

	"github.com/google/uuid"
)

const runCreate = `-- name: RunCreate :exec
INSERT INTO digilab_demo_fbs.runs
(id, year, status, created_at)
VALUES (
    $1, $2, $3, NOW()
)
`

type RunCreateParams struct {
	ID     uuid.UUID
	Year   int32
	Status int32
}

func (q *Queries) RunCreate(ctx context.Context, arg *RunCreateParams) error {
	_, err := q.exec(ctx, q.runCreateStmt, runCreate, arg.ID, arg.Year, arg.Status)
	return err
}

const runGet = `-- name: RunGet :one
SELECT id, internal_id, year, created_at, status
FROM digilab_demo_fbs.runs
WHERE id=$1
`

func (q *Queries) RunGet(ctx context.Context, id uuid.UUID) (*DigilabDemoFbsRun, error) {
	row := q.queryRow(ctx, q.runGetStmt, runGet, id)
	var i DigilabDemoFbsRun
	err := row.Scan(
		&i.ID,
		&i.InternalID,
		&i.Year,
		&i.CreatedAt,
		&i.Status,
	)
	return &i, err
}

const runListAsc = `-- name: RunListAsc :many
SELECT objs.id, objs.internal_id, objs.year, objs.created_at, objs.status FROM (
    SELECT id, internal_id, year, created_at, status
    FROM digilab_demo_fbs.runs    
    WHERE runs.internal_id > (
        SELECT sub_qry.internal_id
        FROM digilab_demo_fbs.runs as sub_qry
        WHERE sub_qry.id=$1
    )
    ORDER BY runs.internal_id ASC
    LIMIT $2
) objs ORDER BY objs.internal_id DESC
`

type RunListAscParams struct {
	ID    uuid.UUID
	Limit int32
}

func (q *Queries) RunListAsc(ctx context.Context, arg *RunListAscParams) ([]*DigilabDemoFbsRun, error) {
	rows, err := q.query(ctx, q.runListAscStmt, runListAsc, arg.ID, arg.Limit)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsRun{}
	for rows.Next() {
		var i DigilabDemoFbsRun
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.Year,
			&i.CreatedAt,
			&i.Status,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const runListDesc = `-- name: RunListDesc :many
SELECT id, internal_id, year, created_at, status
FROM digilab_demo_fbs.runs    
WHERE runs.internal_id < COALESCE((
    SELECT internal_id
    FROM digilab_demo_fbs.runs as sub_qry
    WHERE sub_qry.id=$1
), $2)
ORDER BY runs.internal_id DESC
LIMIT $3
`

type RunListDescParams struct {
	ID         uuid.UUID
	InternalID int32
	Limit      int32
}

func (q *Queries) RunListDesc(ctx context.Context, arg *RunListDescParams) ([]*DigilabDemoFbsRun, error) {
	rows, err := q.query(ctx, q.runListDescStmt, runListDesc, arg.ID, arg.InternalID, arg.Limit)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsRun{}
	for rows.Next() {
		var i DigilabDemoFbsRun
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.Year,
			&i.CreatedAt,
			&i.Status,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const runUpdate = `-- name: RunUpdate :exec
UPDATE digilab_demo_fbs.runs
SET status=$1
WHERE id=$2
`

type RunUpdateParams struct {
	Status int32
	ID     uuid.UUID
}

func (q *Queries) RunUpdate(ctx context.Context, arg *RunUpdateParams) error {
	_, err := q.exec(ctx, q.runUpdateStmt, runUpdate, arg.Status, arg.ID)
	return err
}
